<?php
/**
 *
 * Description
 *
 * @package    VirtueMart
 * @subpackage
 * @author Nanda K
 * @version $Id: priceclass.php 2017-06-07 
 */

// Check to ensure this file is included in Joomla!
defined ('_JEXEC') or die('Restricted access');

if (!class_exists ('VmModel')) {
	require(VMPATH_ADMIN . DS . 'helpers' . DS . 'vmmodel.php');
}

/**
 * Model for VirtueMart PriceClass
 *
 * @package        VirtueMart
 */
class VirtueMartModelPriceClass extends VmModel {

	/**
	 * constructs a VmModel
	 * setMainTable defines the maintable of the model
	 *
	 * @author Max Milbers
	 */
	function __construct () {

		parent::__construct ();

		$this->setMainTable ('priceclass');
	}


	/**
	 * Retrieve the PriceClass details from the database.
	 *
	 * @author Nanda
	 * @return object PriceClass details
	 */
	function getPriceClassDetails ($id = 0) {

		/*if(!empty($id)) $this->_id = (int)$id;

		if (empty($this->_cache[$this->_id][VmConfig::$vmlang])) {

			$this->_cache[$this->_id][VmConfig::$vmlang] = $this->getTable ('priceclass');
			$this->_cache[$this->_id][VmConfig::$vmlang]->load ($this->_id);
		}
			print_r($this->_cache[$this->_id][VmConfig::$vmlang]);
		return $this->_cache[$this->_id][VmConfig::$vmlang];*/
		
		return $this->getPC($id);
	}

	
	/**
	 * Load a single order, Attention, this function is not protected! Do the right manangment before, to be certain
     * we suggest to use getMyOrderDetails
	 */
	public function getPC($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$pc = array();

		// Get the order details
		$q = "SELECT  *
			FROM #__virtuemart_priceclass 
			WHERE id=".$id;
		$db->setQuery($q);
		$pc = $db->loadObjectList();
		return $pc;
	}
	
	public function getSI($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$si = array();

		// Get the order details
		$q = "SELECT  virtuemart_saleitem_id
			FROM #__virtuemart_priceclass_saleitems 
			WHERE virtuemart_priceclass_id=".$id;
		$db->setQuery($q);
		$si = $db->loadColumn();
		return $si;
	}	

	/**
	 * Retrieve a list of PriceClasses
	 * @author Nanda
	 * @return object List of PriceClasses
	 */
	public function getPriceClasses () {

		$this->setId (0); //This is important ! notice by Max Milbers
		$query = 'SELECT * FROM `#__virtuemart_priceclass` as q ';
		$query .= ' ORDER BY q.`id`';
		$this->_data = $this->_getList ($query, $this->getState ('limitstart'), $this->getState ('limit'));
		return $this->_data;
	}
	
	
	public function getPriceClassNames () {
		static $priceClassNames=0;
		if(empty($priceClassNames)){
			$q = 'SELECT `priceclassname`,`id` as `virtuemart_priceclass_id` FROM `#__virtuemart_priceclass` order by `id` ';
			$db = JFactory::getDBO();
			$db->setQuery($q);
			$priceClassNames = $db->loadAssocList('virtuemart_priceclass_id');
		}

		return $priceClassNames;

	}
	
	public function getPG($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$pg = array();

		// Get the order details
		$q = "SELECT  virtuemart_pricegroup_id
			FROM #__virtuemart_pricegroup_priceclasses 
			WHERE virtuemart_priceclass_id=".$id;
		$db->setQuery($q);
		$pg = $db->loadColumn();
		return $pg;
	}
	
	function renderPCList($value,$name = 'priceclassname',$multiple=FALSE,$attrs='',$langkey=''){

		$idA = $id = $name;
 		$attrs .= ' class="inputbox" ';
		if ($multiple) {
			$attrs .= ' multiple="multiple" ';
			if(empty($langkey)) $langkey = 'COM_VIRTUEMART_DRDOWN_SELECT_SOME_OPTIONS';
			$attrs .=  ' data-placeholder="'.vmText::_($langkey).'"';
			$idA .= '[]';
		} else {
			if(empty($langkey)) $langkey = 'COM_VIRTUEMART_LIST_EMPTY_OPTION';
		}

		if (!isset($this->_renderPCList)) {
			$priceClassNames = $this->getPriceClassNames();
			$emptyOption = JHtml::_ ('select.option', -1, vmText::_ ($langkey), 'virtuemart_priceclass_id', 'priceclassname');
			array_unshift ($priceClassNames, $emptyOption);
			if ($multiple) {
				$attrs .=' size="'.count($priceClassNames).'" ';
			}

			$this->_renderPCList = JHtml::_('select.genericlist', $priceClassNames, $idA, $attrs, 'virtuemart_priceclass_id', 'priceclassname', $value,$id,true);
		}
		return $this->_renderPCList ;
	}	

	/**
	 * Bind the post data to the PriceClass table and save it
	 *
	 * @author Nanda
	 * @return boolean True is the save was successful, false otherwise.
	 */
	function store (&$data) {

		$dispatcher = JDispatcher::getInstance ();

		$table = $this->getTable ('priceclass');

		if(empty($data['priceclassname'])){
			if(!empty($data['title'])){
				$data['priceclassname'] = '';
				$data['priceclassname'] = $data['title'].' ';
			}
		}

		$res = $table->bindChecknStore ($data);
		if(!$res) {
			vmError ('Error storing vendor');
		}

		//set vendormodel id to the lastinserted one
		if (empty($this->_id)) {
			$this->_id = $table->id;
		} 
		if (empty($data['id'])) {
			$data['id'] = $this->_id;
		}
		
		if (!empty($data['virtuemart_saleitem_id']) && count ($data['virtuemart_saleitem_id']) > 0) {
			$data['virtuemart_saleitem_id'] = $data['virtuemart_saleitem_id'];
		} else {
			$data['virtuemart_saleitem_id'] = array();
		}		

		if (!empty($data['id'])) {
			$data['virtuemart_priceclass_id'] = $data['id'];
		} else {
			$data['virtuemart_priceclass_id'] = 0;
		}		
		
		$table = $this->getTable ('priceclass_saleitems');
		$res = $table->bindChecknStore ($data);
		//print_r($data);
		
		return $this->_id;

	}

}
