<?php
/**
 *
 * Description
 *
 * @package    VirtueMart
 * @subpackage
 * @author Nanda K
 * @version $Id: pricegroup.php 2017-17-07 
 */

// Check to ensure this file is included in Joomla!
defined ('_JEXEC') or die('Restricted access');

if (!class_exists ('VmModel')) {
	require(VMPATH_ADMIN . DS . 'helpers' . DS . 'vmmodel.php');
}

/**
 * Model for VirtueMart PriceGroup
 *
 * @package        VirtueMart
 */
class VirtueMartModelPriceGroup extends VmModel {

	/**
	 * constructs a VmModel
	 * setMainTable defines the maintable of the model
	 *
	 * @author Max Milbers
	 */
	function __construct () {

		parent::__construct ();

		$this->setMainTable ('pricegroup');
	}


	/**
	 * Retrieve the PriceGroup details from the database.
	 *
	 * @author Nanda
	 * @return object SaleItem details
	 */
	function getPriceGroupDetails ($id = 0) {
		
		return $this->getPG($id);
	}

	
	/**
	 * Load a single order, Attention, this function is not protected! Do the right manangment before, to be certain
     * we suggest to use getMyOrderDetails
	 */
	public function getPG($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$pg = array();

		// Get the order details
		$q = "SELECT  *
			FROM #__virtuemart_pricegroup 
			WHERE virtuemart_pricegroup_id=".$id;
		$db->setQuery($q);
		$pg = $db->loadObjectList();
		return $pg;
	}
	
	public function getSI($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$si = array();

		// Get the order details
		$q = "SELECT  virtuemart_saleitem_id
			FROM #__virtuemart_pricegroup_saleitems 
			WHERE virtuemart_pricegroup_id=".$id;
		$db->setQuery($q);
		$si = $db->loadColumn();
		return $si;
	}
	
	public function getPC($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$si = array();

		// Get the order details
		$q = "SELECT  virtuemart_priceclass_id
			FROM #__virtuemart_pricegroup_priceclasses 
			WHERE virtuemart_pricegroup_id=".$id;
		$db->setQuery($q);
		$si = $db->loadColumn();
		return $si;
	}
	
	public function getQB1($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$si = array();

		// Get the order details
		$q = "SELECT  virtuemart_qb_id
			FROM #__virtuemart_pricegroup_qb1 
			WHERE virtuemart_pricegroup_id=".$id;
		$db->setQuery($q);
		$si = $db->loadColumn();
		return $si;
	}	

	public function getQB2($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$si = array();

		// Get the order details
		$q = "SELECT  virtuemart_qb_id
			FROM #__virtuemart_pricegroup_qb2 
			WHERE virtuemart_pricegroup_id=".$id;
		$db->setQuery($q);
		$si = $db->loadColumn();
		return $si;
	}	
	
	public function getQB3($id){

		//sanitize id
		$id = (int)$id;
		$db = JFactory::getDBO();
		$si = array();

		// Get the order details
		$q = "SELECT  virtuemart_qb_id
			FROM #__virtuemart_pricegroup_qb3 
			WHERE virtuemart_pricegroup_id=".$id;
		$db->setQuery($q);
		$si = $db->loadColumn();
		return $si;
	}
	
	/**
	 * Retrieve a list of PriceClasses
	 * @author Nanda
	 * @return object List of PriceClasses
	 */
	public function getPriceGroups () {

		$this->setId (0); //This is important ! notice by Max Milbers
		$query = 'SELECT * FROM `#__virtuemart_pricegroup` as q ';
		$query .= ' ORDER BY q.`virtuemart_pricegroup_id`';
		$this->_data = $this->_getList ($query, $this->getState ('limitstart'), $this->getState ('limit'));
		return $this->_data;
	}


	/**
	 * Bind the post data to the PriceClass table and save it
	 *
	 * @author Nanda
	 * @return boolean True is the save was successful, false otherwise.
	 */
	function store (&$data) {

		$dispatcher = JDispatcher::getInstance ();

		$table = $this->getTable ('pricegroup');

		if(empty($data['pricegroupname'])){
			if(!empty($data['title'])){
				$data['pricegroupame'] = '';
				$data['pricegroupname'] = $data['title'].' ';
			}
		}

		$res = $table->bindChecknStore ($data);
		if(!$res) {
			vmError ('Error storing vendor');
		}

		//set vendormodel id to the lastinserted one
		if (empty($this->_virtuemart_pricegroup_id)) {
			$this->_virtuemart_pricegroup_id = $table->virtuemart_pricegroup_id;
		} 
		if (empty($data['virtuemart_pricegroup_id'])) {
			$data['virtuemart_pricegroup_id'] = $this->_virtuemart_pricegroup_id;
		}
		
		if (!empty($data['virtuemart_saleitem_id']) && count ($data['virtuemart_saleitem_id']) > 0) {
			$data['virtuemart_saleitem_id'] = $data['virtuemart_saleitem_id'];
		} else {
			$data['virtuemart_saleitem_id'] = array();
		}		

		if (!empty($data['virtuemart_pricegroup_id']) ) {
			$data['virtuemart_pricegroup_id'] = $data['virtuemart_pricegroup_id'];
		} else {
			$data['virtuemart_pricegroup_id'] = 0;
		}		
		
		if (!empty($data['virtuemart_priceclass_id']) && count ($data['virtuemart_priceclass_id']) > 0) {
			$data['virtuemart_priceclass_id'] = $data['virtuemart_priceclass_id'];
		} else {
			$data['virtuemart_priceclass_id'] = array();
		}		
		
		
		/*if (!empty($data['id'])) {
			$data['virtuemart_pricegroup_id'] = $data['id'];
		} else {
			$data['virtuemart_pricegroup_id'] = 0;
		}*/		
		
		$table = $this->getTable ('pricegroup_saleitems');
		$res = $table->bindChecknStore ($data);
		
		$table = $this->getTable ('pricegroup_priceclasses');
		$res = $table->bindChecknStore ($data);

		if (!empty($data['virtuemart_qb1_id']) && count ($data['virtuemart_qb1_id']) > 0) {
			$data['virtuemart_qb_id'] = $data['virtuemart_qb1_id'];
		} else {
			$data['virtuemart_qb_id'] = array();
		}
		
		$table = $this->getTable ('pricegroup_qb1');
		$res = $table->bindChecknStore ($data);

		if (!empty($data['virtuemart_qb2_id']) && count ($data['virtuemart_qb2_id']) > 0) {
			$data['virtuemart_qb_id'] = $data['virtuemart_qb2_id'];
		} else {
			$data['virtuemart_qb_id'] = array();
		}
		
		$table = $this->getTable ('pricegroup_qb2');
		$res = $table->bindChecknStore ($data);
		
		if (!empty($data['virtuemart_qb3_id']) && count ($data['virtuemart_qb3_id']) > 0) {
			$data['virtuemart_qb_id'] = $data['virtuemart_qb3_id'];
		} else {
			$data['virtuemart_qb_id'] = array();
		}
		
		$table = $this->getTable ('pricegroup_qb3');
		$res = $table->bindChecknStore ($data);		
		
		//print_r($data);
		
		return $this->_virtuemart_pricegroup_id;

	}

}
