<?php
/**
 *
 * PriceGroup View
 *
 * @package	VirtueMart
 * @subpackage PriceGroup
 * @author Nanda Kishore
 * @version $Id: view.html.php 2017-17-07 
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

// Load the view framework
if(!class_exists('VmViewAdmin'))require(VMPATH_ADMIN.DS.'helpers'.DS.'vmviewadmin.php');

/**
 * HTML View class for maintaining the list of PriceGroups
 *
 * @package	VirtueMart
 * @subpackage PriceGroup
 * @author Nanda Kishore
 */
class VirtuemartViewPriceGroup extends VmViewAdmin {

	function display($tpl = null) {

		// Load the helper(s)
		if (!class_exists('VmHTML'))
			require(VMPATH_ADMIN . DS . 'helpers' . DS . 'html.php');

		// get necessary models
		$model = VmModel::getModel('pricegroup');

		$this->SetViewTitle();

		$layoutName = vRequest::getCmd('layout', 'default');
		if ($layoutName == 'edit') {
			$pg_id = vRequest::getInt('virtuemart_pricegroup_id');
			$this->pricegroup = $model->getPriceGroupDetails($pg_id);
			$this->virtuemart_pg_id = $pg_id;
			$isNew = ($this->pricegroup->virtuemart_pricegroup_id < 1);
			$this->addStandardEditViewCommands($this->pricegroup->virtuemart_pricegroup_id);
			
			
			//Nanda
			$salieitemM =VmModel::getModel('saleitem');
			$salieitems = $model->getSI($pg_id);
			$this->virtuemart_pricegroup_id = $this->pricegroup[0]->virtuemart_pricegroup_id;
			$this->lists['saleitem_list'] = $salieitemM->renderSIList($salieitems,'saleitemname',TRUE);
			
			
			$priceclassM =VmModel::getModel('priceclass');
			$priceclasses = $model->getPC($pg_id);
			$this->lists['priceclass_list'] = $priceclassM->renderPCList($priceclasses,'priceclassname',TRUE);			
			
			$qbM =VmModel::getModel('qb');
			$qb1 = $model->getQB1($pg_id);
			$this->lists['qb1'] = $qbM->renderQBList($qb1,'qb1name',TRUE);
			
			$qb2 = $model->getQB2($pg_id);
			$this->lists['qb2'] = $qbM->renderQB2List($qb2,'qb2name',TRUE);
			
			$qb3 = $model->getQB3($pg_id);
			$this->lists['qb3'] = $qbM->renderQB3List($qb3,'qb3name',TRUE);
		}
		else {
			$mainframe = JFactory::getApplication();
			$this->addStandardDefaultViewCommands();
			$this->addStandardDefaultViewLists($model,'pricegroup');

			$this->pricegroup = $model->getPriceGroups();
			$this->pagination = $model->getPagination();
		}
		parent::display($tpl);
	}
}
// pure php no closing tag
